# Uses of Enum Class
org.bukkit.block.BlockFace

Packages that use BlockFace
Package
Description
com.destroystokyo.paper.block
io.papermc.paper.block
io.papermc.paper.event.block
io.papermc.paper.math
org.bukkit.block
Classes used to manipulate the voxels in a `world`, including special states.
org.bukkit.block.data
Generalized BlockData classes.
org.bukkit.block.data.type
Specific BlockData classes relevant to only a given block or set of blocks.
org.bukkit.entity
Interfaces for non-voxel objects that can exist in a `world`, including all players, monsters, projectiles, etc.
org.bukkit.event.block
`Events` relating to when a `block` is changed or interacts with the `world`.
org.bukkit.event.entity
`Events` relating to `entities`, excluding some directly referencing some more specific entity types.
org.bukkit.event.hanging
`Events` relating to `entities that hang`.
org.bukkit.event.player
`Events` relating to `players`.
org.bukkit.material
Classes that represents various voxel types and states.
org.bukkit.material.types
Classes relevant to specific material types.
org.bukkit.util
Multi and single purpose classes to facilitate various programmatic concepts.

## Uses of BlockFace in com.destroystokyo.paper.block

Methods in com.destroystokyo.paper.block that return BlockFace
Modifier and Type
Method
Description
`@NotNull BlockFace`
TargetBlockInfo.`getBlockFace()`
Get the targeted BlockFace
Constructors in com.destroystokyo.paper.block with parameters of type BlockFace
Modifier
Constructor
Description
``
`TargetBlockInfo(@NotNull Block block, @NotNull BlockFace blockFace)`

## Uses of BlockFace in io.papermc.paper.block

Methods in io.papermc.paper.block that return BlockFace
Modifier and Type
Method
Description
`@NotNull BlockFace`
MovingPiston.`getDirection()`
The direction that the current moving piston is pushing/pulling a block in.

## Uses of BlockFace in io.papermc.paper.event.block

Constructors in io.papermc.paper.event.block with parameters of type BlockFace
Modifier
Constructor
Description
``
`TargetHitEvent(@NotNull Projectile projectile, @NotNull Block block, @NotNull BlockFace blockFace, int signalStrength)`

## Uses of BlockFace in io.papermc.paper.math

Methods in io.papermc.paper.math with parameters of type BlockFace
Modifier and Type
Method
Description
`default @NotNull BlockPosition`
BlockPosition.`offset(@NotNull BlockFace blockFace)`
Returns a block position offset by 1 in the direction specified.
`default @NotNull BlockPosition`
BlockPosition.`offset(@NotNull BlockFace blockFace, int amount)`
Returns a block position offset in the direction specified multiplied by the amount.

## Uses of BlockFace in org.bukkit.block

Methods in org.bukkit.block that return BlockFace
Modifier and Type
Method
Description
`@Nullable BlockFace`
Block.`getFace(@NotNull Block block)`
Gets the face relation of this block compared to the given block.
`@NotNull BlockFace`
BlockFace.`getOppositeFace()`
`@NotNull BlockFace`
Skull.`getRotation()`
Deprecated.
use `BlockData`
`static BlockFace`
BlockFace.`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static BlockFace[]`
BlockFace.`values()`
Returns an array containing the constants of this enum class, in the order they are declared.
Methods in org.bukkit.block with parameters of type BlockFace
Modifier and Type
Method
Description
`boolean`
Block.`applyBoneMeal(@NotNull BlockFace face)`
Simulate bone meal application to this block (if possible).
`int`
Block.`getBlockPower(@NotNull BlockFace face)`
Returns the redstone power being provided to this block face
`@NotNull Block`
Block.`getRelative(@NotNull BlockFace face)`
Gets the block at the given face
`@NotNull Block`
Block.`getRelative(@NotNull BlockFace face, int distance)`
Gets the block at the given distance of the given face
`boolean`
Block.`isBlockFaceIndirectlyPowered(@NotNull BlockFace face)`
Returns true if the block face is being indirectly powered by Redstone.
`boolean`
Block.`isBlockFacePowered(@NotNull BlockFace face)`
Returns true if the block face is being powered by Redstone.
`void`
Skull.`setRotation(@NotNull BlockFace rotation)`
Deprecated.
use `BlockData`

## Uses of BlockFace in org.bukkit.block.data

Methods in org.bukkit.block.data that return BlockFace
Modifier and Type
Method
Description
`@NotNull BlockFace`
Directional.`getFacing()`
Gets the value of the 'facing' property.
`@NotNull BlockFace`
Rotatable.`getRotation()`
Gets the value of the 'rotation' property.
Methods in org.bukkit.block.data that return types with arguments of type BlockFace
Modifier and Type
Method
Description
`@NotNull Set<BlockFace>`
MultipleFacing.`getAllowedFaces()`
Gets all of this faces which may be set on this block.
`@NotNull Set<BlockFace>`
Directional.`getFaces()`
Gets the faces which are applicable to this block.
`@NotNull Set<BlockFace>`
MultipleFacing.`getFaces()`
Get all of the faces which are enabled on this block.
Methods in org.bukkit.block.data with parameters of type BlockFace
Modifier and Type
Method
Description
`boolean`
MultipleFacing.`hasFace(@NotNull BlockFace face)`
Checks if this block has the specified face enabled.
`boolean`
BlockData.`isFaceSturdy(@NotNull BlockFace face, @NotNull BlockSupport support)`
Checks if a state's `BlockFace` is capable of providing a given level of `BlockSupport` for neighbouring block states.
`void`
MultipleFacing.`setFace(@NotNull BlockFace face, boolean has)`
Set whether this block has the specified face enabled.
`void`
Directional.`setFacing(@NotNull BlockFace facing)`
Sets the value of the 'facing' property.
`void`
Rotatable.`setRotation(@NotNull BlockFace rotation)`
Sets the value of the 'rotation' property.

## Uses of BlockFace in org.bukkit.block.data.type

Methods in org.bukkit.block.data.type that return BlockFace
Modifier and Type
Method
Description
`@NotNull BlockFace`
PointedDripstone.`getVerticalDirection()`
Gets the value of the 'vertical_direction' property.
Methods in org.bukkit.block.data.type that return types with arguments of type BlockFace
Modifier and Type
Method
Description
`@NotNull Set<BlockFace>`
RedstoneWire.`getAllowedFaces()`
Gets all of this faces which may be set on this block.
`@NotNull Set<BlockFace>`
PointedDripstone.`getVerticalDirections()`
Gets the faces which are applicable to this block.
Methods in org.bukkit.block.data.type with parameters of type BlockFace
Modifier and Type
Method
Description
`@NotNull RedstoneWire.Connection`
RedstoneWire.`getFace(@NotNull BlockFace face)`
Checks the type of connection on the specified face.
`@NotNull Wall.Height`
Wall.`getHeight(@NotNull BlockFace face)`
Gets the height of the specified face.
`void`
RedstoneWire.`setFace(@NotNull BlockFace face, @NotNull RedstoneWire.Connection connection)`
Sets the type of connection on the specified face.
`void`
Wall.`setHeight(@NotNull BlockFace face, @NotNull Wall.Height height)`
Set the height of the specified face.
`void`
PointedDripstone.`setVerticalDirection(@NotNull BlockFace direction)`
Sets the value of the 'vertical_direction' property.

## Uses of BlockFace in org.bukkit.entity

Methods in org.bukkit.entity that return BlockFace
Modifier and Type
Method
Description
`@NotNull BlockFace`
Shulker.`getAttachedFace()`
Gets the face to which the shulker is attached.
`BlockFace`
ShulkerBullet.`getCurrentMovementDirection()`
Gets the current movement direction.
`@NotNull BlockFace`
Entity.`getFacing()`
Get the closest cardinal `BlockFace` direction an entity is currently facing.
`default BlockFace`
LivingEntity.`getTargetBlockFace(int maxDistance)`
Gets the blockface of that block that the living entity has targeted, ignoring fluids
`BlockFace`
LivingEntity.`getTargetBlockFace(int maxDistance, TargetBlockInfo.FluidMode fluidMode)`
Gets the blockface of that block that the living entity has targeted
Methods in org.bukkit.entity with parameters of type BlockFace
Modifier and Type
Method
Description
`void`
Shulker.`setAttachedFace(@NotNull BlockFace face)`
Sets the face to which the shulker is attached.
`void`
ShulkerBullet.`setCurrentMovementDirection(BlockFace movementDirection)`
Set the current movement direction.
`boolean`
Hanging.`setFacingDirection(@NotNull BlockFace face, boolean force)`
Sets the direction of the hanging entity, potentially overriding rules of placement.

## Uses of BlockFace in org.bukkit.event.block

Fields in org.bukkit.event.block declared as BlockFace
Modifier and Type
Field
Description
`protected BlockFace`
BlockFromToEvent.`face`
Methods in org.bukkit.event.block that return BlockFace
Modifier and Type
Method
Description
`@NotNull BlockFace`
BlockPistonEvent.`getDirection()`
Return the direction in which the piston will operate.
`@NotNull BlockFace`
BlockFromToEvent.`getFace()`
Gets the BlockFace that the block is moving to.
Constructors in org.bukkit.event.block with parameters of type BlockFace
Modifier
Constructor
Description
``
`BlockFromToEvent(@NotNull Block block, @NotNull BlockFace face)`
``
`BlockPistonEvent(@NotNull Block block, @NotNull BlockFace direction)`
``
`BlockPistonExtendEvent(@NotNull Block block, int length, @NotNull BlockFace direction)`
Deprecated.
``
`BlockPistonExtendEvent(@NotNull Block block, @NotNull List<Block> blocks, @NotNull BlockFace direction)`
``
`BlockPistonRetractEvent(@NotNull Block block, @NotNull List<Block> blocks, @NotNull BlockFace direction)`

## Uses of BlockFace in org.bukkit.event.entity

Methods in org.bukkit.event.entity that return BlockFace
Modifier and Type
Method
Description
`@NotNull BlockFace`
EntityPlaceEvent.`getBlockFace()`
Returns the face of the block that the entity was placed on
`@Nullable BlockFace`
ProjectileHitEvent.`getHitBlockFace()`
Gets the block face that was hit, if it was a block that was hit and the face was provided in the vent.
Constructors in org.bukkit.event.entity with parameters of type BlockFace
Modifier
Constructor
Description
``
`EntityPlaceEvent(@NotNull Entity entity, @Nullable Player player, @NotNull Block block, @NotNull BlockFace blockFace)`
Deprecated.
``
`EntityPlaceEvent(@NotNull Entity entity, @Nullable Player player, @NotNull Block block, @NotNull BlockFace blockFace, @NotNull EquipmentSlot hand)`
``
`ProjectileHitEvent(@NotNull Projectile projectile, @Nullable Entity hitEntity, @Nullable Block hitBlock, @Nullable BlockFace hitFace)`

## Uses of BlockFace in org.bukkit.event.hanging

Methods in org.bukkit.event.hanging that return BlockFace
Modifier and Type
Method
Description
`@NotNull BlockFace`
HangingPlaceEvent.`getBlockFace()`
Returns the face of the block that the hanging entity was placed on
Constructors in org.bukkit.event.hanging with parameters of type BlockFace
Modifier
Constructor
Description
``
`HangingPlaceEvent(@NotNull Hanging hanging, @Nullable Player player, @NotNull Block block, @NotNull BlockFace blockFace, @Nullable EquipmentSlot hand)`
Deprecated.
``
`HangingPlaceEvent(@NotNull Hanging hanging, @Nullable Player player, @NotNull Block block, @NotNull BlockFace blockFace, @Nullable EquipmentSlot hand, @Nullable ItemStack itemStack)`

## Uses of BlockFace in org.bukkit.event.player

Fields in org.bukkit.event.player declared as BlockFace
Modifier and Type
Field
Description
`protected BlockFace`
PlayerInteractEvent.`blockFace`
Methods in org.bukkit.event.player that return BlockFace
Modifier and Type
Method
Description
`@NotNull BlockFace`
PlayerBucketEvent.`getBlockFace()`
Get the face on the clicked block
`@NotNull BlockFace`
PlayerInteractEvent.`getBlockFace()`
Returns the face of the block that was clicked
Constructors in org.bukkit.event.player with parameters of type BlockFace
Modifier
Constructor
Description
``
`PlayerBucketEmptyEvent(@NotNull Player who, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand)`
Deprecated.
``
`PlayerBucketEmptyEvent(@NotNull Player who, @NotNull Block block, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand)`
Deprecated.
``
`PlayerBucketEmptyEvent(@NotNull Player who, @NotNull Block block, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand, @NotNull EquipmentSlot hand)`
``
`PlayerBucketEvent(@NotNull Player who, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand)`
Deprecated.
``
`PlayerBucketEvent(@NotNull Player who, @NotNull Block block, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand)`
Deprecated.
``
`PlayerBucketEvent(@NotNull Player who, @NotNull Block block, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand, @NotNull EquipmentSlot hand)`
``
`PlayerBucketFillEvent(@NotNull Player who, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand)`
Deprecated.
``
`PlayerBucketFillEvent(@NotNull Player who, @NotNull Block block, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand)`
Deprecated.
``
`PlayerBucketFillEvent(@NotNull Player who, @NotNull Block block, @NotNull Block blockClicked, @NotNull BlockFace blockFace, @NotNull Material bucket, @NotNull ItemStack itemInHand, @NotNull EquipmentSlot hand)`
``
`PlayerInteractEvent(@NotNull Player who, @NotNull Action action, @Nullable ItemStack item, @Nullable Block clickedBlock, @NotNull BlockFace clickedFace)`
``
`PlayerInteractEvent(@NotNull Player who, @NotNull Action action, @Nullable ItemStack item, @Nullable Block clickedBlock, @NotNull BlockFace clickedFace, @Nullable EquipmentSlot hand)`
``
`PlayerInteractEvent(@NotNull Player who, @NotNull Action action, @Nullable ItemStack item, @Nullable Block clickedBlock, @NotNull BlockFace clickedFace, @Nullable EquipmentSlot hand, @Nullable Location interactionPoint)`

## Uses of BlockFace in org.bukkit.material

Fields in org.bukkit.material declared as BlockFace
Modifier and Type
Field
Description
`protected static final BlockFace`
Comparator.`DEFAULT_DIRECTION`
Deprecated.
`protected static final BlockFace`
Diode.`DEFAULT_DIRECTION`
Deprecated.
`protected static final BlockFace`
Hopper.`DEFAULT_DIRECTION`
Deprecated.
`protected static final BlockFace`
Tree.`DEFAULT_DIRECTION`
Deprecated.
Methods in org.bukkit.material that return BlockFace
Modifier and Type
Method
Description
`BlockFace`
Stairs.`getAscendingDirection()`
Deprecated.
`@NotNull BlockFace`
Attachable.`getAttachedFace()`
Gets the face that this block is attached on
`BlockFace`
Banner.`getAttachedFace()`
Deprecated.
`BlockFace`
Button.`getAttachedFace()`
Deprecated.
Gets the face that this block is attached on
`BlockFace`
CocoaPlant.`getAttachedFace()`
Deprecated.
`BlockFace`
Ladder.`getAttachedFace()`
Deprecated.
Gets the face that this block is attached on
`BlockFace`
Lever.`getAttachedFace()`
Deprecated.
Gets the face that this block is attached on
`BlockFace`
PistonExtensionMaterial.`getAttachedFace()`
Deprecated.
`BlockFace`
Sign.`getAttachedFace()`
Deprecated.
Gets the face that this block is attached on
`BlockFace`
Torch.`getAttachedFace()`
Deprecated.
Gets the face that this block is attached on
`BlockFace`
TrapDoor.`getAttachedFace()`
Deprecated.
`BlockFace`
TripwireHook.`getAttachedFace()`
Deprecated.
`BlockFace`
Stairs.`getDescendingDirection()`
Deprecated.
`BlockFace`
Rails.`getDirection()`
Deprecated.
`BlockFace`
Tree.`getDirection()`
Deprecated.
Get direction of the log
`BlockFace`
Banner.`getFacing()`
Deprecated.
`BlockFace`
Bed.`getFacing()`
Deprecated.
Get the direction that this bed's head is facing toward
`BlockFace`
CocoaPlant.`getFacing()`
Deprecated.
`BlockFace`
Comparator.`getFacing()`
Deprecated.
Gets the direction this comparator is facing
`BlockFace`
Diode.`getFacing()`
Deprecated.
Gets the direction this diode is facing
`@NotNull BlockFace`
Directional.`getFacing()`
Gets the direction this block is facing
`BlockFace`
DirectionalContainer.`getFacing()`
Deprecated.
`BlockFace`
Dispenser.`getFacing()`
Deprecated.
`BlockFace`
Door.`getFacing()`
Deprecated.
Get the direction that this door is facing.
`BlockFace`
Gate.`getFacing()`
Deprecated.
`BlockFace`
Hopper.`getFacing()`
Deprecated.
Gets the direction this hopper is facing
`BlockFace`
Observer.`getFacing()`
Deprecated.
`BlockFace`
PistonBaseMaterial.`getFacing()`
Deprecated.
`BlockFace`
PistonExtensionMaterial.`getFacing()`
Deprecated.
`BlockFace`
Pumpkin.`getFacing()`
Deprecated.
`BlockFace`
Sign.`getFacing()`
Deprecated.
Gets the direction that this sign is currently facing
`BlockFace`
SimpleAttachableMaterialData.`getFacing()`
Deprecated.
`BlockFace`
Skull.`getFacing()`
Deprecated.
`BlockFace`
Stairs.`getFacing()`
Deprecated.
`BlockFace`
Door.`getHingeCorner()`
Deprecated.
This method should not be used; use hinge and facing accessors instead.
Methods in org.bukkit.material that return types with arguments of type BlockFace
Modifier and Type
Method
Description
`Set<BlockFace>`
Mushroom.`getPaintedFaces()`
Deprecated.
Methods in org.bukkit.material with parameters of type BlockFace
Modifier and Type
Method
Description
`boolean`
Mushroom.`isFacePainted(BlockFace face)`
Deprecated.
Checks whether a face of the block is painted with cap texture.
`boolean`
Vine.`isOnFace(BlockFace face)`
Deprecated.
Check if the vine is attached to the specified face of an adjacent block.
`void`
Vine.`putOnFace(BlockFace face)`
Deprecated.
Attach the vine to the specified face of an adjacent block.
`void`
Vine.`removeFromFace(BlockFace face)`
Deprecated.
Detach the vine from the specified face of an adjacent block.
`void`
ExtendedRails.`setDirection(BlockFace face, boolean isOnSlope)`
Deprecated.
`void`
Rails.`setDirection(BlockFace face, boolean isOnSlope)`
Deprecated.
Set the direction of these tracks
`void`
Tree.`setDirection(BlockFace dir)`
Deprecated.
Set direction of the log
`void`
Mushroom.`setFacePainted(BlockFace face, boolean painted)`
Deprecated.
Use MushroomBlockType cap options
`void`
Banner.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
Bed.`setFacingDirection(BlockFace face)`
Deprecated.
Set which direction the head of the bed is facing.
`void`
Button.`setFacingDirection(BlockFace face)`
Deprecated.
Sets the direction this button is pointing toward
`void`
CocoaPlant.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
Comparator.`setFacingDirection(BlockFace face)`
Deprecated.
Sets the direction this comparator is facing
`void`
Diode.`setFacingDirection(BlockFace face)`
Deprecated.
Sets the direction this diode is facing.
`void`
Directional.`setFacingDirection(@NotNull BlockFace face)`
Sets the direction that this block is facing in
`void`
DirectionalContainer.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
Dispenser.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
Door.`setFacingDirection(BlockFace face)`
Deprecated.
Set the direction that this door should is facing.
`void`
Gate.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
Hopper.`setFacingDirection(BlockFace face)`
Deprecated.
Sets the direction this hopper is facing
`void`
Ladder.`setFacingDirection(BlockFace face)`
Deprecated.
Sets the direction this ladder is facing
`void`
Lever.`setFacingDirection(BlockFace face)`
Deprecated.
Sets the direction this lever is pointing in
`void`
Observer.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
PistonBaseMaterial.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
PistonExtensionMaterial.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
Pumpkin.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
Sign.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
Skull.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
Stairs.`setFacingDirection(BlockFace face)`
Deprecated.
Set the direction the stair part of the block is facing
`void`
Torch.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
TrapDoor.`setFacingDirection(BlockFace face)`
Deprecated.
`void`
TripwireHook.`setFacingDirection(BlockFace face)`
Deprecated.
Constructors in org.bukkit.material with parameters of type BlockFace
Modifier
Constructor
Description
``
`Bed(BlockFace direction)`
Deprecated.
Instantiate a bed facing in a particular direction.
``
`Chest(BlockFace direction)`
Deprecated.
Instantiate a chest facing in a particular direction.
``
`CocoaPlant(CocoaPlant.CocoaPlantSize sz, BlockFace dir)`
Deprecated.
``
`Comparator(BlockFace facingDirection)`
Deprecated.
Constructs a comparator switched off, with the default mode (normal) and facing the specified direction.
``
`Comparator(BlockFace facingDirection, boolean isSubtraction)`
Deprecated.
Constructs a comparator switched off, with the specified mode and facing the specified direction.
``
`Comparator(BlockFace facingDirection, boolean isSubtraction, boolean state)`
Deprecated.
Constructs a comparator switched on or off, with the specified mode and facing the specified direction.
``
`Diode(BlockFace facingDirection)`
Deprecated.
Constructs a diode switched off, with a delay of 1 and facing the specified direction.
``
`Diode(BlockFace facingDirection, int delay)`
Deprecated.
Constructs a diode switched off, with the specified delay and facing the specified direction.
``
`Diode(BlockFace facingDirection, int delay, boolean state)`
Deprecated.
Constructs a diode switched on or off, with the specified delay and facing the specified direction.
``
`Dispenser(BlockFace direction)`
Deprecated.
``
`Door(Material type, BlockFace face)`
Deprecated.
Constructs the bottom half of a door of the given material type, facing the specified direction and set to closed
``
`Door(Material type, BlockFace face, boolean isOpen)`
Deprecated.
Constructs the bottom half of a door of the given material type, facing the specified direction and set to open or closed
``
`Door(TreeSpecies species, BlockFace face)`
Deprecated.
Constructs the bottom half of a wooden door of the given species, facing the specified direction and set to closed
``
`Door(TreeSpecies species, BlockFace face, boolean isOpen)`
Deprecated.
Constructs the bottom half of a wooden door of the given species, facing the specified direction and set to open or closed
``
`EnderChest(BlockFace direction)`
Deprecated.
Instantiate an ender chest facing in a particular direction.
``
`Furnace(BlockFace direction)`
Deprecated.
Instantiate a furnace facing in a particular direction.
``
`Hopper(BlockFace facingDirection)`
Deprecated.
Constructs a hopper facing the specified direction and initially active.
``
`Hopper(BlockFace facingDirection, boolean isActive)`
Deprecated.
Constructs a hopper facing the specified direction and either active or not.
``
`Mushroom(Material shroom, BlockFace capFace)`
Deprecated.
Constructs a brown/red mushroom cap block with the specified face or faces set to cap texture.
``
`Observer(BlockFace direction)`
Deprecated.
``
`Pumpkin(BlockFace direction)`
Deprecated.
Instantiate a pumpkin facing in a particular direction.
``
`SimpleAttachableMaterialData(Material type, BlockFace direction)`
Deprecated.
``
`Skull(BlockFace direction)`
Deprecated.
Instantiate a skull facing in a particular direction.
``
`Tree(Material type, TreeSpecies species, BlockFace dir)`
Deprecated.
Constructs a tree block of the given type and tree species, and facing the given direction.
``
`Tree(TreeSpecies species, BlockFace dir)`
Deprecated.
Constructs a tree block of the given tree species, and facing the given direction.
``
`TripwireHook(BlockFace dir)`
Deprecated.
``
`Vine(BlockFace... faces)`
Deprecated.
Constructor parameters in org.bukkit.material with type arguments of type BlockFace
Modifier
Constructor
Description
``
`Vine(EnumSet<BlockFace> faces)`
Deprecated.

## Uses of BlockFace in org.bukkit.material.types

Methods in org.bukkit.material.types that return BlockFace
Modifier and Type
Method
Description
`@Nullable BlockFace`
MushroomBlockTexture.`getCapFace()`
Deprecated.
Gets the face that has cap texture.
Methods in org.bukkit.material.types with parameters of type BlockFace
Modifier and Type
Method
Description
`static @Nullable MushroomBlockTexture`
MushroomBlockTexture.`getCapByFace(@Nullable BlockFace face)`
Deprecated.
Gets the MushroomBlockType with cap texture on the given block face.

## Uses of BlockFace in org.bukkit.util

Methods in org.bukkit.util that return BlockFace
Modifier and Type
Method
Description
`@Nullable BlockFace`
RayTraceResult.`getHitBlockFace()`
Gets the hit block face.
Methods in org.bukkit.util with parameters of type BlockFace
Modifier and Type
Method
Description
`@NotNull BoundingBox`
BoundingBox.`expand(@NotNull BlockFace blockFace, double expansion)`
Expands this bounding box in the direction specified by the given block face.
Constructors in org.bukkit.util with parameters of type BlockFace
Modifier
Constructor
Description
``
`RayTraceResult(@NotNull Vector hitPosition, @Nullable BlockFace hitBlockFace)`
Creates a RayTraceResult.
``
`RayTraceResult(@NotNull Vector hitPosition, @Nullable Block hitBlock, @Nullable BlockFace hitBlockFace)`
Creates a RayTraceResult.
``
`RayTraceResult(@NotNull Vector hitPosition, @Nullable Entity hitEntity, @Nullable BlockFace hitBlockFace)`
Creates a RayTraceResult.